SGATCC/Areas/Coordenador/Controllers/UsuariosController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using SGATCC.Areas.Coordenador.Services.Interface;
using SGATCC.Areas.Coordenador.ViewModel;
using SGATCC.Contexto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;

namespace SGATCC.Areas.Coordenador.Controllers
{
    [Area("Coordenador")]
    [Authorize(Roles = "Coordenador")]
    public class UsuariosController : Controller
    {
        private readonly UserManager<IdentityUser> _userManager;
        private readonly IUsuarioService _usuarioService;
        private readonly ContextoSGATCC _context;

        public UsuariosController(UserManager<IdentityUser> userManager, IUsuarioService usuarioService, ContextoSGATCC context)
        {
            _userManager = userManager;
            _usuarioService = usuarioService;
            _context = context;
        }
        [HttpGet]
        public IActionResult GerenciarUsuarios()
        {
            var model = new GerenciaUsuariosViewModel();

            return View(model);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Registrar(RegistrarViewModel registroViewModel)
        {
            //if(registroViewModel.TipoUsuario == "Professor" && string.IsNullOrEmpty(registroViewModel.DisciplinaId))
            //{
            //    return Json(new { Erro = true, Msg = "Informe a Disciplina", Alert = true });
            //}
            if (registroViewModel.Password.Length < 6)
            {
                return Json(new { Erro = true, Msg = "A senha deve ter pelo menos 6 caracteres", Alert = true });
            }

            if (registroViewModel.Password != registroViewModel.PasswordConfirm)
            {
                return Json(new { Erro = true, Msg = "Senhas não conferem" });
            }

            var verificaUsuario = _usuarioService.VerificaUsuarioCadastrado(registroViewModel.UserName);

            if (verificaUsuario)
            {
                return Json(new { Erro = true, Msg = "Usuário Já está Cadastrado" });
            }

            //Cria Usuário
            var user = new IdentityUser
            {
                UserName = registroViewModel.UserName,
            };

            //if (!string.IsNullOrEmpty(registroViewModel.DisciplinaId))
            //{
            //    user.DisciplinaId = int.Parse(registroViewModel.DisciplinaId);
            //}


            var result = await _userManager.CreateAsync(user, registroViewModel.Password);

            if (result.Succeeded)
            {
                if (registroViewModel.TipoUsuario == "Coordenador")
                {
                    await _userManager.AddToRoleAsync(user, "Coordenador");
                }
                else
                {
                    await _userManager.AddToRoleAsync(user, "Professor");
                }

                return Json(new { Erro = false, Msg = "Usuário Cadastrado com Sucesso!" });
            }
            else
            {
                return Json(new { Erro = true, Msg = result.Errors.FirstOrDefault() });
            }
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult PesquisaUsuariosCadastrados(GerenciaUsuariosViewModel model)
        {
            var lstUsuarios = _usuarioService.PesquisaUsuariosCadastrados(model);

            if (lstUsuarios.Count() > 0)
            {
                return PartialView("_lstUsuarios", lstUsuarios);
            }

            return Json(new { Erro = true, Msg = "Usuário Não Existe!" });
        }

        public IActionResult CriarUsuario()
        {
            var dados = _usuarioService.ListarRoles();
            
            var lista = new List<SelectListItem> { new SelectListItem { Text = "Selecione o tipo de Usuario", Value = "" } };
            lista.AddRange(dados.Select(x => new SelectListItem { Text = x.Name, Value = x.Name }));

            var disciplinas = _context.Disciplinas.ToList();

            var listaDisciplinas = new List<SelectListItem> { new SelectListItem { Text = "Selecione a Disciplina", Value = "" } };
            listaDisciplinas.AddRange(disciplinas.Select(x => new SelectListItem { Text = x.Descricao, Value = x.Id.ToString() }));

            ViewBag.Roles = lista;
            ViewBag.Disciplinas = listaDisciplinas;

            return PartialView("_CriarUsuario");
        }

        public IActionResult Excluir(string id)
        {
            var model = new ExcluirViewModel()
            {
                Id = id
            };
            return PartialView("_ExcluirUsuario", model);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> ExcluirUsuario(string id)
        {
            var usuario = await _userManager.FindByIdAsync(id);

            await _userManager.DeleteAsync(usuario);

            return Json(new { Erro = false, Msg = "Usuário Excluido com Sucesso!" });
        }

        public async Task<IActionResult> Editar(string id)
        {
            var dados = _usuarioService.ListarRoles();

            var lista = new List<SelectListItem> { new SelectListItem { Text = "Selecione o tipo de Usuario", Value = "" } };
            lista.AddRange(dados.Select(x => new SelectListItem { Text = x.Name, Value = x.Name }));

            ViewBag.Roles = lista;

            var usuario = await _userManager.FindByIdAsync(id);
            var role = _usuarioService.BuscarRole(id);

            var model = new AtualizarUsuarioViewModel()
            {
                Id = usuario.Id,
                NomeDeUsuario = usuario.UserName,
                Role = role
            };

            return View("EditarUsuario", model);
        }

        [HttpPost]
        public async Task<IActionResult> EditarUsuario(AtualizarUsuarioViewModel registroViewModel)
        {
            try
            {
                if (!string.IsNullOrEmpty(registroViewModel.NovaSenha))
                {
                    if (registroViewModel.NovaSenha.Length < 6)
                    {
                        return Json(new { Erro = true, Msg = "A senha deve ter pelo menos 6 caracteres", Alert = true });
                    }

                    if (registroViewModel.NovaSenha != registroViewModel.ConfirmaNovaSenha)
                    {
                        return Json(new { Erro = true, Msg = "Senhas não conferem" });
                    }
                }

                var splitNomeUsuario = registroViewModel.NomeDeUsuario.Split(' ');

                if (splitNomeUsuario.Count() > 1)
                    return Json(new { Erro = true, Msg = "Nome de Usuario não pode conter espaços" });

                var user = await _userManager.FindByIdAsync(registroViewModel.Id);
                user.UserName = registroViewModel.NomeDeUsuario;
                user.SecurityStamp = Guid.NewGuid().ToString();

                await _userManager.UpdateAsync(user);

                //ATUALIZA SENHA

                if (!string.IsNullOrEmpty(registroViewModel.NovaSenha))
                {
                    var token = await _userManager.GeneratePasswordResetTokenAsync(user);

                    await _userManager.ResetPasswordAsync(user, token, registroViewModel.NovaSenha);
                }

                //ATUALIZA ROLE

                var oldRole = _usuarioService.BuscarRole(registroViewModel.Id);

                var result = await _userManager.RemoveFromRoleAsync(user, oldRole);


                await _userManager.AddToRoleAsync(user, registroViewModel.Role);

                return Json(new { Erro = false, Msg = registroViewModel.NomeDeUsuario + " atualizado com sucesso!" });
            }
            catch (Exception ex)
            {

                return Json(new { Erro = true, Msg = ex });
            }
        }

    }

}

SGATCC/Areas/Coordenador/Views/Usuarios/EditarUsuario.cshtml
@model AtualizarUsuarioViewModel

<div class="row">
    <div class="col-md-12">
        <div id="PainelMensagemEditarUsuario" class=" alert fade show m-2" style="display:none" role="alert">
            <span id="MensagemEditarUsuario"></span>
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    </div>
</div>

<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Editar Usuário
        </div>
    </div>
    <div class="card-body">
        <form class="form-signin" asp-controller="Usuarios" asp-action="EditarUsuario" data-ajax="true"
              data-ajax-method="post"
              data-ajax-begin="editarBegin"
              data-ajax-success="editarSuccess"
              id="formEdtiarUsuario">

            <input asp-for="Id" hidden />
            <div class="row">
                <div class="col-md-3">
                    <label>Tipo de Usuário</label>
                    <select asp-for="Role" class="form-control" asp-items="ViewBag.Roles" required autofocus></select>
                </div>
                <div class="col-md-3">
                    <label asp-for="NomeDeUsuario"></label>
                    <input asp-for="NomeDeUsuario" class="form-control" required autofocus>
                    <span asp-validation-for="NomeDeUsuario" class="text-danger"></span>
                </div>
                <div class="col-md-3">
                    <label asp-for="NovaSenha"></label>
                    <input asp-for="NovaSenha" class="form-control" required autofocus>
                    <span asp-validation-for="NovaSenha" class="text-danger"></span>
                </div>
                <div class="col-md-3">
                    <label asp-for="ConfirmaNovaSenha"></label>
                    <input asp-for="ConfirmaNovaSenha" class="form-control" required autofocus>
                    <span asp-validation-for="ConfirmaNovaSenha" class="text-danger"></span>
                </div>
                <div class="col-md-3" style="margin-top:10px">
                    <label>Deseja Atualizar a Senha ?</label>
                    <div class="form-check form-check-inline">
                        <input class="form-check-input radioSenha" type="radio" name="radio" value="sim" onclick="verificaSenha()">
                        <label class="form-check-label" for="inlineRadio1">Sim</label>
                    </div>
                    <div class="form-check form-check-inline">
                        <input class="form-check-input radioSenha" checked="checked" type="radio" name="radio" value="nao" onclick="verificaSenha()">
                        <label class="form-check-label" for="inlineRadio2">Não</label>
                    </div>
                </div>
            </div>
            <input type="submit" class="btn btn-primary" value="Atualizar" />
            <hr class="my-4">
        </form>
    </div>
</div>


<script>

    window.addEventListener("load", () => {
        $('#NovaSenha').attr("disabled", "true");
        $('#ConfirmaNovaSenha').attr("disabled", "true");
    })

    function editarBegin() {
        $('#formEdtiarUsuario').loading();

    }

    function editarSuccess(xhr) {
        if (xhr.erro == true) {
            $('#PainelMensagemEditarUsuario').addClass('alert-danger');
            $('#MensagemEditarUsuario').html(xhr.msg);
            $('#PainelMensagemEditarUsuario').show();
        } else {
            $('#PainelMensagemEditarUsuario').addClass('alert-success');
            $('#MensagemEditarUsuario').html(xhr.msg);
            $('#PainelMensagemEditarUsuario').show();
        }
        $('#formEdtiarUsuario').loading('stop');
    }


    function verificaSenha() {
        var botao = $('.radioSenha:checked').val();

        if (botao == 'nao') {
            $('#NovaSenha').attr("disabled", "true");
            $('#ConfirmaNovaSenha').attr("disabled", "true");
        } else {
            $('#NovaSenha').removeAttr('disabled');
            $('#ConfirmaNovaSenha').removeAttr('disabled');
        }
    }
</script>

SGATCC/Areas/Coordenador/Views/Usuarios/GerenciarUsuarios.cshtml
@model SGATCC.Areas.Coordenador.ViewModel.GerenciaUsuariosViewModel

<div>
    <i class="fas fa-user-plus"></i><button class="btn btn-link" id="criaUsuario" style="margin-left:8px">Cadastrar Novo Usuário</button>
</div>
<br />
<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Pesquisa
        </div>
    </div>
    <form asp-action="PesquisaUsuariosCadastrados" asp-controller="Usuarios" asp-area="Coordenador" data-ajax="true"
          data-ajax-method="post"
          data-ajax-update="#resultadoPesquisaUsuarios"
          data-ajax-begin="pesquisaUsuariosBegin"
          data-ajax-success="pesquisaUsuariosSuccess"
          id="formPesquisaUsuarios">

        <div class="card-body">
            <div class="row">
                <div class="col-md-3">
                    <label asp-for="Filtro.Nome"></label>
                    <input class="form form-control" asp-for="Filtro.Nome" />
                </div>
            </div>
            <div class="row">
                <div class="col-md-4" style="margin-top:20px">
                    <input type="submit" class="btn btn-primary" value="Pesquisar" />
                </div>
            </div>
        </div>
    </form>
</div>


<div class="row">
    <div id="PainelMensagem" class="col-md-12 alert fade show m-2" style="display:none" role="alert">
        <span id="Mensagem"></span>
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
</div>

<div id="resultadoPesquisaUsuarios"></div>



<div class="modal fade" id="modalIncluirUsuario" tabindex="-1" role="dialog" aria-labelledby="modalIncluirUsuario" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
        </div>
    </div>
</div>

<div class="modal fade" id="modalExcluir" tabindex="-1" role="dialog" aria-labelledby="modalExcluir" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
        </div>
    </div>
</div>


@section Scripts{

    <script>
        $(document).ready(function () {
            $('#criaUsuario').click(criarUsuario);
        });

        function pesquisaUsuariosBegin() {
            $('#formPesquisaUsuarios').loading();
        }

        function pesquisaUsuariosSuccess(xhr) {
            $('#formPesquisaUsuarios').loading('stop');
            if (xhr.erro == true) {
                $('#PainelMensagem').addClass('alert-danger');
                $('#Mensagem').html(xhr.msg);
                $('#PainelMensagem').show();
            }

            InitDataTableExport("#tableUsuarios");
        }

        function criarUsuario() {
            $.ajax({
                type: "GET",
                datatype: 'html',
                url: 'CriarUsuario',
                success: function (xhr) {
                    $('#modalIncluirUsuario').modal();
                    $('.modal-content').html(xhr);
                }
            })
        }


    </script>
}

SGATCC/Areas/Coordenador/Views/Usuarios/_CriarUsuario.cshtml
@model RegistrarViewModel;

<div class="row">
    <div class="col-md-12">
        <div id="PainelMensagemCadsatrarUsuario" class=" alert fade show m-2" style="display:none" role="alert">
            <span id="MensagemCadastrarUsuario"></span>
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    </div>
</div>
<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Cadastrar Novo Usuário
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    </div>
    <div class="card-body">
        <form class="form-signin" asp-controller="Usuarios" asp-action="Registrar" data-ajax="true"
              data-ajax-method="post"
              data-ajax-begin="criarUsuarioBegin"
              data-ajax-success="criarUsuarioSuccess"
              id="formCadastrarUsuarios">


            <div class="form-label-group">
                <select asp-for="TipoUsuario" asp-items="ViewBag.Roles" class="form-control" placeholder="Tipo de Usuário" required autofocus></select>
                <br />
            </div> 
            <div class="form-label-group" id="divDisciplina" style="display:none">
                <select asp-for="DisciplinaId" asp-items="ViewBag.Disciplinas" class="form-control" autofocus></select>
                <br />
            </div>
            <div class="form-label-group">
                <input asp-for="UserName" class="form-control" placeholder="Usuário" required autofocus>
                <span asp-validation-for="UserName" class="text-danger"></span>
                <br />
            </div>

            <div class="form-label-group">
                <input asp-for="Password" class="form-control" placeholder="Senha" required autofocus>
                <span asp-validation-for="Password" class="text-danger"></span>
                <br />
            </div>
            <div class="form-label-group">
                <input asp-for="PasswordConfirm" class="form-control" placeholder="Confirmar Senha" required autofocus>
                <span asp-validation-for="PasswordConfirm" class="text-danger"></span>
                <br />
            </div>
            <br />
            <button class="btn btn-lg btn-primary btn-block " type="submit">Cadastrar</button>
            <hr class="my-4">
        </form>
    </div>
</div>

<script>

    //$(document).ready(() => {
    //    $("#TipoUsuario").change(() => {
    //        var tipo = $("#TipoUsuario").val();

    //        if (tipo == "Professor") {
    //            $("#divDisciplina").show()
    //        } else {
    //            $("#divDisciplina").hide()
    //        }
    //    })
    //})

    function criarUsuarioBegin() {
        $('#formCadastrarUsuarios').loading();
    }

    function criarUsuarioSuccess(xhr) {
        if (xhr.erro == true) {
            $('#PainelMensagemCadsatrarUsuario').addClass('alert-danger');
            $('#MensagemCadastrarUsuario').html(xhr.msg);
            $('#PainelMensagemCadsatrarUsuario').show();

            setTimeout(() => {
                $('#PainelMensagemCadsatrarUsuario').hide();
            }, 3000)
        } else {
            $('#PainelMensagemCadsatrarUsuario').addClass('alert-success');
            $('#MensagemCadastrarUsuario').html(xhr.msg);
            $('#PainelMensagemCadsatrarUsuario').show();

            setTimeout(() => {
                $('#modalIncluirUsuario').modal("hide");
                $('#formPesquisaUsuarios').submit();
            }, 3000)
        }
        $('#formCadastrarUsuarios').loading('stop');

    }
</script>

SGATCC/Areas/Coordenador/Views/Usuarios/_ExcluirUsuario.cshtml
@model ExcluirViewModel

<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Excluir Usuario
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    </div>
    <div class="card-body">
        <form class="form-signin" asp-area="Coordenador" asp-controller="Usuarios" asp-action="ExcluirUsuario" data-ajax="true"
              data-ajax-method="post"
              data-ajax-begin="ExcluirUsuarioBegin"
              data-ajax-success="ExcluirUsuarioSuccess"
              id="formExcluirUsuarios">
           
            <div class="modal-body">
                <h5>Deseja realmente remover esse Usuário?</h5>
                <input asp-for="Id" hidden />
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Não</button>
                <input type="submit" class="btn btn-primary" value="Sim" />
            </div>
        </form>
    </div>
</div>

<script>
    function ExcluirUsuarioBegin() {
        $('#formExcluirUsuarios').loading();
    }

    function ExcluirUsuarioSuccess(xhr) {
        $('#modalExcluir').modal('hide');
        $('#PainelMensagem').addClass('alert-success');
        $('#Mensagem').html(xhr.msg);
        $('#PainelMensagem').show();
        $('#formExcluirUsuarios').loading('stop');
        setTimeout(function () {
            $('#formPesquisaUsuarios').submit();
            $('#modalExcluir').modal("hide");
            $('#PainelMensagem').hide();
        },1000)
    }
</script>

SGATCC/Areas/Coordenador/Views/Usuarios/_lstUsuarios.cshtml
@model List<Microsoft.AspNetCore.Identity.IdentityUser>

<br />
<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Usuários Cadastrados
        </div>
    </div>
    <div class="card-body">
        <table class="table" id="tableUsuarios">

            <thead>
                <tr>
                    <th>
                        Ações
                    </th>
                    <th>
                        Usuario
                    </th>
                </tr>
            </thead>
            @foreach (var item in Model)
            {
                <tbody>
                    <tr>
                        <td>
                            <a href="#" class="fas fa-trash icone-admin excluir" data-id="@item.Id" style="color:red" title="Excluir Usuário"></a>
                            @*<a href="#" class="fas fa-user-edit editar" data-id="@item.Id" title="Editar Usuário"></a>*@
                            <a class="fas fa-user-edit" asp-action="Editar" asp-route-id="@item.Id" title="Editar Usuário"></a>
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.UserName)
                        </td>
                    </tr>
                </tbody>
            }
        </table>
    </div>
</div>


<script>

    $(document).ready(function () {
       
        $('.excluir').click(function () {
            var botao = $(this);
            var id = botao.attr('data-id');

            $.ajax({
                url: 'Excluir',
                type: 'GET',
                datatype: 'html',
                data: { id: id },
                success: function (xhr) {
                    $('.modal-content').html(xhr);
                    $('#modalExcluir').modal();
                }
            });
        });

        //$('.editar').click(function () {
        //    var botao = $(this);
        //    var id = botao.attr('data-id');

        //    $.ajax({
        //        type: "GET",
        //        datatype: 'html',
        //        url: 'Editar',
        //        data: { id: id },
        //        success: function (xhr) {
        //            $('#modalEditar').modal();
        //            $('.modal-content').html(xhr);
        //        }
        //    })
        //});
    })

</script>